Note: This is a beta release of Red Hat Bugzilla 5.0. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Also email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback here.
Bug 448196 - LTSP keyboard layout problem
Summary: LTSP keyboard layout problem
Keywords:
Status: CLOSED RAWHIDE
Alias: None
Product: Fedora
Classification: Fedora
Component: ltsp
Version: 9
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Kristian Høgsberg
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On:
Blocks: K12LTSP
TreeView+ depends on / blocked
 
Reported: 2008-05-24 10:05 UTC by Zoltan Boszormenyi
Modified: 2009-03-09 07:53 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2008-08-08 04:29:45 UTC


Attachments (Terms of Use)

Description Zoltan Boszormenyi 2008-05-24 10:05:59 UTC
Description of problem:

ltsp-build-client created an en_US.UTF-8 client with US keyboard layout.
I would like all-Hungarian clients. Changing "i18n" and "keyboard" under
/opt/ltsp/i386/etc/sysconfig is only giving me a hu_HU.UTF-8 client
with Hungarian messages on the login screen but still with US keyboard.
Changing /var/lib/tftpboot/ltsp/i386/lts.conf so it contains an "XKBLAYOUT=hu"
line didn't help. The lts.conf in /opt/ltsp/i386/etc is empty by default
and modifying it (actually, copying the lts.conf from the tftpboot area to
the ltsp chroot) didn't help either.

Version-Release number of selected component (if applicable):

ltsp-server-5.1.7-2.fc9.x86_64

How reproducible:

Always.

Steps to Reproduce:
1. ltsp-build-client
2. modify lts.conf, .../sysconfig/{i18n,keyboard}
3.
  
Actual results:

Locale can be modified on the client but not the keyboard layout.

Expected results:

Both locale and keyboard should follow some of the settings.

Additional info:

For ltsp-build-client, it would be best to parse the host configuration
and build the client with the proper locale and keyboard layout by default.

Comment 1 Warren Togami 2008-05-25 03:06:35 UTC
It appears that XKBLAYOUT is only recognized by ltsp-trunk/client/configure-x.sh
which Fedora does not use.  This is an unfortunate side-effect of Fedora's
default of X autoconfiguration which is to run without an xorg.conf.

Our choices are either:
1) Figure out a way to use an externally specified layout during X
autoconfiguration.  Is this possible with current X code?
2) Configure X separately into an xorg.conf file then mangle that xorg.conf
file, like ltsp-trunk/client/configure-x.sh.  It would be unfortunate if we have
to take this path. =(

Any suggestions from the X team?


Comment 2 Jeremy Katz 2008-05-27 14:49:36 UTC
Have your greeter read the locale config and set up keyboard/language
appropriately.  

Comment 3 Warren Togami 2008-05-27 18:03:53 UTC
> Have your greeter read the locale config and set up keyboard/language
> appropriately.

How do you define appropriately?  You cannot easily assume a certain keyboard
layout by the locale alone.

I asked Ray Strode about how gdm and GNOME handle keyboard layout.  It is a bit
complicated.  GNOME desktop's gnome-settings-daemon reads a layout option from
gconf and sets it during login.  gdm also runs gnome-settings-daemon but Ray
thinks gdm uses only whatever layout is defined by the X server (meaning this
isn't a solved problem in gdm either.)

Comment 4 Warren Togami 2008-05-27 18:45:40 UTC
<jeremy> warren: you'd have to use the specified keyboard mapping and then use
the bits in rhpl.keyboard_models to do mapping
<warren> jeremy: is there a canonical place in /etc that contains the system's
keyboard mapping?
<jeremy> warren: /etc/sysconfig/keyboard is as much as there is

Comment 5 Zoltan Boszormenyi 2008-06-06 15:05:36 UTC
Another data point: the console is conforming to the keyboard setting found
/etc/sysconfig/keyboard. I pressed Ctrl-Alt-F2 to go to the console on the
thin client and I got my hungarian keyboard. Only X doesn't follow currently.

Comment 6 Warren Togami 2008-06-16 20:22:36 UTC
Talked with Matthias Clasen of the desktop team.  He suggested looking at gdm's
greeter implementation of keyboard layout chooser.  The chooser sets the gconf
option which is used by gnome-settings-daemon to set the keyboard layout.  We
either need to implement much of this ourselves for ldm, or attempt to use
gnome-settings-daemon which pulls in a lot of extra stuff into the client
chroot.  Not sure what is the best way forward yet.  Investigating.

Comment 7 Warren Togami 2008-08-08 04:29:45 UTC
A fix using lts.conf XKB* options in a standard upstream LTSP fashion has been pushed as part of ltsp-5.1.15 to Fedora 9.

Comment 8 Keir Stitt 2009-03-08 21:34:53 UTC
I've got the same problem on Fedora10 using xfce.

I'm using a UK English layout keyboard. Works fine when I boot into run level 3, or if I press Ctrl + Alt + 2 to get a bash shell in tty2. Its only when i'm using X that every time I log-on I get the default US keyboard layout.

I can go to [fedorabutton]|Settings|Keyboard and change it to UK layout, but this only lasts until the next login (plus requires the root password).

Comment 9 Warren Togami 2009-03-09 07:53:41 UTC
Keir, please file that as a bug against XFCE.  XFCE isn't respecting the keyboard layout set in hal.


Note You need to log in before you can comment on or make changes to this bug.